import "Thurallor.BagDescrambler";

Turbine.Shell.WriteLine("Inventory Bag ID Descrambler v" ..  plugin:GetVersion() .. ", by Thurallor");

Player = Turbine.Gameplay.LocalPlayer:GetInstance();
Bags = Player:GetBackpack();
SlotsFound = 1;
NextSlot = {};

local height = 250;
Window = Turbine.UI.Lotro.Window();
Window:SetVisible(true);
Window:SetSize(300, height);
Window:SetTop((Turbine.UI.Display:GetHeight() - height) / 2);
Window:SetLeft((Turbine.UI.Display:GetWidth() - 300) / 4);
Window:SetText("ID Descrambler");
Window:SetAllowDrop(true);
function Window:DragEnter(args)
end
function Window:DragDrop(args)
    if (Wizard.pane ~= 3) then
        return;
    end
    local item = args.DragDropInfo:GetShortcut():GetItem();
    for n = 1, Bags:GetSize() do
        if (Bags:GetItem(n) == item) then
            Puts("Found " .. item:GetName() .. " in slot " .. n);
        end
    end
end

Wizard = Turbine.UI.Control();
Wizard:SetParent(Window);
Wizard:SetMouseVisible(false);
Wizard:SetPosition(25, 45);
Wizard:SetSize(250, height - 100);

Instructions = Turbine.UI.Label();
Instructions:SetParent(Wizard);
Instructions:SetMouseVisible(false);
Instructions:SetSize(250, height - 100);
Instructions:SetMultiline(true);
Instructions:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
Instructions:SetText("Please make sure your bags are completely full, except for one empty slot.  Get stuff from your vault if necessary.\n\nThere must be a unique item in each slot.  (If you have stackable items, combine them into one stack.  If you have two identical earrings/bracelets/rings, keep only one in your bags.)");

Continue = Turbine.UI.Lotro.Button();
Continue:SetParent(Window);
Continue:SetWidth(100);
Continue:SetPosition(100, height - 42);
Continue:SetText("Continue");
function Continue:Click()
    Wizard:Continue();
end

SlotLabel = Turbine.UI.Window();
SlotLabel:SetBackground("Thurallor/BagDescrambler/slot.tga");
SlotLabel:SetSize(56, 58);
SlotLabel:SetZOrder(2);
SlotLabel:SetMouseVisible(false);
function SlotLabel:Show(num)
    self.Num:SetText(num);
    self:SetVisible(true);
    self:SetPosition(Turbine.UI.Display.GetMouseX() - 52, Turbine.UI.Display.GetMouseY() - 54);
    self.startTime = Turbine.Engine.GetGameTime();
    self:SetWantsUpdates(true);
end
function SlotLabel:Update()
    local currentTime = Turbine.Engine.GetGameTime();
    local opacity = 2 - (currentTime - self.startTime); -- opacity > 1 is the same as opacity == 1
    self:SetOpacity(opacity);
    if (opacity <= 0) then
        self:SetVisible(false);
        self:SetWantsUpdates(false);
    end
end
Num = Turbine.UI.Label();
SlotLabel.Num = Num;
Num:SetParent(SlotLabel);
Num:SetSize(44, 44);
Num:SetPosition(0, 1);
Num:SetFont(Turbine.UI.Lotro.Font.TrajanPro19);
Num:SetFontStyle(Turbine.UI.FontStyle.Outline);
Num:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
Num:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
Num:SetMouseVisible(false);

Wizard.pane = 1;
function Wizard:Continue()
    self.pane = self.pane + 1;
    if (self.pane == 2) then
        Instructions:SetText("Please click the Sort button at the top of Bag 1.  The empty slot will be moved to the first slot in your bags.");
    elseif (self.pane == 3) then
        Instructions:SetText("Now move the empty space to the second slot, by moving the item there into the first slot.");
        Continue:SetVisible(false);
    elseif (self.pane == 4) then
        Instructions:SetText("Continue moving the empty space from slot to slot, until it arrives at the end of your bags.\n\nCompleted: " .. SlotsFound .. " of " .. Bags:GetSize());
        self.pane = self.pane - 1; -- repeat this pane
    elseif (self.pane == 5) then
        Instructions:SetText("Discovery complete.");
        Continue:SetVisible(true);
        Continue:SetText("Descramble");
    elseif (self.pane == 6) then
        local slot = FirstSlot;
        for n = 2, Bags:GetSize() do
            local item = Bags:GetItem(slot);
            if (item) then
                slot = NextSlot[slot];
                Bags:PerformItemDrop(item, n, false);
            end
        end
        Instructions:SetText("Items have been rearranged.  Please click the Sort button at the top of Bag 1 to complete the process.");
        Continue:SetText("Continue");
    elseif (self.pane == 7) then
        Instructions:SetText("Your bags are now descrambled.  The slots are numbered consecutively, starting with slot 1 at the top of Bag 1 and ending with slot " .. Bags:GetSize() .. ".\n\nYou may now check that the operation was successful by moving items around in your bags and looking at the chat window messages.");
    elseif (self.pane == 8) then
        Continue:SetText("Finish");
        Instructions:SetText("Never use the Sort button in your bags, or it will scramble the IDs and you'll have to descramble them again.\n\nTo prevent that from happening accidentally, you may enable the warning dialog by clicking \"Reset Confirmation Dialogs\" in the UI Settings options panel.");
    elseif (self.pane == 9) then
        Window:Close();
    elseif (self.pane == 10) then
        Instructions:SetText("You screwed up.  You need to reload this plugin and start over.");
        Continue:SetVisible(false);
    end
end
function Bags:ItemMoved(args)
    if (Wizard.pane == 6) then
        -- Don't want to spam the chat window while descrambling.
        return;
    end
    Puts("Item moved from slot " .. args.OldIndex .. " to slot " .. args.NewIndex .. ".");
    SlotLabel:Show(args.NewIndex);
    if ((Wizard.pane < 3) or (Wizard.pane > 4)) then
        return;
    end
    SlotsFound = SlotsFound + 1;
    if (SlotsFound == 2) then
        FirstSlot = args.NewIndex;
    end
    if (NextSlot[args.NewIndex] ~= nil) then
        Wizard.pane = 9; -- pane 10 = error
        Wizard:Continue();
    end
    NextSlot[args.NewIndex] = args.OldIndex;
    if (SlotsFound == Bags:GetSize()) then
        Wizard.pane = 4;
    end
    Wizard:Continue();
end
